&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : rtb_rpt_task.p
    Description : Roundtable task reports procedure library

    Created     : Nov 2002
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
{rtb/i/rtb_rptinit.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 14
         WIDTH              = 61.6.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-rptRtbTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbTask Procedure 
PROCEDURE rptRtbTask :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace-id    AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PbegTask      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PendTask      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PshowTaskNotes    AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects  AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowDetails  AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowVerNotes AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.
  
  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).
  
  RUN rtb_task_report (Pwspace-id,
                       PbegTask,
                       PendTask,
                       PshowTaskNotes,
                       PshowObjects,
                       PshowDetails,
                       PshowVerNotes).

  OUTPUT STREAM Sout CLOSE.

  RETURN.
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbTaskOrphans) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbTaskOrphans Procedure 
PROCEDURE rptRtbTaskOrphans :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ptask-num    AS INTEGER   NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.
  
  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).
  
  RUN rtb_task_orphans (Ptask-num).

  OUTPUT STREAM Sout CLOSE.

  DELETE OBJECT PhTT.

  RETURN.
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_task_orphans) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_task_orphans Procedure 
PROCEDURE rtb_task_orphans :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ptask-num AS INTEGER    NO-UNDO.
  
  DEFINE VARIABLE Morphan-count AS INTEGER    NO-UNDO.

  DEFINE BUFFER Brtb_task FOR rtb.rtb_task.
  DEFINE BUFFER Brtb_ver  FOR rtb.rtb_ver.
  DEFINE BUFFER B2rtb_ver FOR rtb.rtb_ver.
  
  $RPT-BLOCK:
  DO:

    {rtb/i/rtb_rpthdr.i 
         &title="""Object Orphans in Task Report"""
         &criteria="""Task #:"" + STRING(Ptask-num)"
         &center-criteria=YES
         &STREAM=Sout}

    /*
     Find all Objects associated with task.
    */
    FOR EACH Brtb_ver NO-LOCK
      WHERE Brtb_ver.task-num = Ptask-num: 
     
      /*
       Note that the index on rtb_ver has version component descending
      */
      IF Brtb_ver.version EQ Brtb_ver.prev-version THEN NEXT.
    
      FOR EACH B2rtb_ver NO-LOCK 
        WHERE B2rtb_ver.pmod     = Brtb_ver.pmod
          AND B2rtb_ver.obj-type = Brtb_ver.obj-type
          AND B2rtb_ver.object   = Brtb_ver.object
          AND B2rtb_ver.version  < Brtb_ver.version
          AND B2rtb_ver.version  > Brtb_ver.prev-version
        WITH FRAME object-frame STREAM-IO:   
    
        /*
         Count orphan records.
        */
        ASSIGN Morphan-count = Morphan-count + 1.
    
        /*
         Display orphaned object.
        */
        FIND Brtb_task OF B2rtb_ver NO-LOCK.
        
        DISPLAY STREAM Sout
          B2rtb_ver.object
          Brtb_ver.version
          B2rtb_ver.version LABEL "Orphaned Ver."
          Brtb_task.wspace-id
          B2rtb_ver.pmod
          WITH FRAME orphan-frame 2 COLUMNS STREAM-IO.
          
       END. /* each b2rtb_ver */
       
    END. /* each brtb_ver */

    PUT STREAM Sout
      SKIP(1) Morphan-count " Orphaned Record(s) Found." SKIP.

    {rtb/i/rtb_rptftr.i &STREAM=Sout}

  END. /* $RPT-BLOCK */
  
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_task_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_task_report Procedure 
PROCEDURE rtb_task_report :
/*------------------------------------------------------------------------------
  Purpose:     Print a task report
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pwspace-id     AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PbegTask       AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PendTask       AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PshowTaskNotes AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects   AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowDetails   AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowVerNotes  AS LOGICAL     NO-UNDO.

  DEFINE VARIABLE Mdescription AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mline        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MlineIn      AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MlineOut     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mprogrammers AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MtextLines   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MtotActHours AS DECIMAL     NO-UNDO.
  DEFINE VARIABLE MtotEstHours AS DECIMAL     NO-UNDO.
  DEFINE VARIABLE Mi           AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mj           AS INTEGER     NO-UNDO.

  DEFINE BUFFER Brtb_task FOR rtb.rtb_task.
  DEFINE BUFFER Brtb_tnot FOR rtb.rtb_tnot.
  DEFINE BUFFER Brtb_ver  FOR rtb.rtb_ver.
  DEFINE BUFFER Brtb_hist FOR rtb.rtb_hist.

  $RPT-BLOCK:
  DO:

    {rtb/i/rtb_rpthdr.i 
         &title="""Task Report"""
         &criteria="""Workspace:""  Pwspace-id                    SKIP
                    ""From Task: "" PbegTask   FORMAT "999999999" SKIP
                    ""  To Task: "" PendTask   FORMAT "999999999" SKIP"
         &center-criteria=NO
         &STREAM=Sout}

    FOR EACH Brtb_task NO-LOCK 
      WHERE Brtb_task.wspace-id MATCHES Pwspace-id
        AND Brtb_task.task-num  >= PbegTask
        AND Brtb_task.task-num  <= PendTask
      BREAK BY Brtb_task.task-num:

      PAGE STREAM Sout.
      
      /*
       Trim programmers list if too long
      */
      Mprogrammers = IF LENGTH(Brtb_task.programmer) > 60 THEN
                       SUBSTRING(Brtb_task.programmer,1,60) + "..."
                     ELSE
                       Brtb_task.programmer.
      
      DISPLAY STREAM Sout
        FILL("-", 120)         FORMAT "x(120)" 
        Brtb_task.task-num                           COLON 14
        Brtb_task.wspace-id                          COLON 40 SKIP
        Brtb_task.entered-when LABEL "Entered"       COLON 14 
        Brtb_task.compltd-when LABEL "Completed"     COLON 40 
        Brtb_task.compltd-by   LABEL "By"            COLON 56 SKIP
        Brtb_task.manager                            COLON 14 
        Mprogrammers           LABEL "Programmer(s)" COLON 14 SKIP
        Brtb_task.summary      FORMAT "X(100)"       COLON 14 SKIP(1)
        WITH FRAME task-frame STREAM-IO SIDE-LABELS NO-BOX WIDTH 120.

      /*
       Print the task description...
       Gather up the non-blank lines, then break it into 100-char lines.
      */
      MlineIn = "".
      DO Mj = 15 TO 1 BY -1:
        IF Brtb_task.description[Mj] <> "" THEN LEAVE.
      END.
      
      DO Mi = 1 TO Mj:
        ASSIGN MlineIn = MlineIn + Brtb_task.description[Mi] + CHR(10).
      END.

      MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', MlineIn, 100).
      DO WHILE MlineOut <> ?:
        PUT STREAM Sout UNFORMATTED "      " MlineOut SKIP.
        MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', ?, 100).
      END.
      
      PUT STREAM Sout FILL("-", 120) FORMAT "x(120)".
              
      IF PshowTaskNotes AND CAN-FIND(FIRST Brtb_tnot OF Brtb_task) THEN DO:
        
        PUT STREAM Sout SKIP(1) "Task Notations" SKIP.
        PUT STREAM Sout UNFORMATTED FILL("-", 14) SKIP.
        
        FOR EACH Brtb_tnot OF Brtb_task NO-LOCK:
          
          DISPLAY STREAM Sout
            Brtb_tnot.note-type                      COLON 10
            Brtb_tnot.entered-when LABEL "Entered"   COLON 30
            Brtb_tnot.user-name    LABEL "By"        COLON 47
            Brtb_tnot.note-priority                  COLON 70 SKIP
            Brtb_tnot.note-status                    COLON 10
            Brtb_tnot.compltd-when LABEL "Completed" COLON 30
            Brtb_tnot.compltd-by   LABEL "By"        COLON 47
            Brtb_tnot.est-hours                      COLON 70 SKIP 
            Brtb_tnot.pmod         FORMAT "X(20)"    COLON 10 
            Brtb_tnot.obj-type                       COLON 37
            Brtb_tnot.version                        COLON 54
            Brtb_tnot.act-hours                      COLON 70 SKIP 
            Brtb_tnot.object       FORMAT "X(100)"   COLON 10 SKIP(1)
          WITH FRAME notes-frame STREAM-IO SIDE-LABELS NO-BOX WIDTH 120.

          /*
           Print the task notation description...
           Gather up the non-blank lines, then break it into 100-char lines.
          */
          MlineIn = "".
          DO Mj = 15 TO 1 BY -1:
            IF Brtb_tnot.description[Mj] <> "" THEN LEAVE.
          END.
      
          DO Mi = 1 TO Mj:
            MlineIn = MlineIn + Brtb_tnot.description[Mi] + CHR(10).
          END.

          MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', MlineIn, 100).
          DO WHILE MlineOut <> ?:
            PUT STREAM Sout UNFORMATTED "      " MlineOut SKIP.
            MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', ?, 100).
          END.

          ASSIGN 
            MtotEstHours = MtotEstHours + Brtb_tnot.est-hours
            MtotActHours = MtotActHours + Brtb_tnot.act-hours.
          
          PUT STREAM Sout SKIP(1).
          
        END. /* of FOR EACH Brtb_tnot OF Brtb_task */
        
        PUT STREAM Sout "Total Estimated Hours: " STRING(MtotEstHours) SKIP.
        PUT STREAM Sout "         Actual Hours: " STRING(MtotActHours) SKIP.
        PUT STREAM Sout " " SKIP.
        
      END. /* PshowTaskNotes */

      IF PshowObjects THEN DO:
        
        IF CAN-FIND(FIRST Brtb_ver OF Brtb_task) THEN DO:
          PUT STREAM Sout UNFORMATTED SKIP(1) "Task Versions" SKIP.
          PUT STREAM Sout UNFORMATTED FILL("-", 13) SKIP.
        END.
        
        FOR EACH Brtb_ver NO-LOCK  
          WHERE Brtb_ver.task-num = Brtb_task.task-num
          BREAK BY Brtb_ver.obj-type
                BY Brtb_ver.object
                BY Brtb_ver.version DESCENDING:

          RUN rtb_get_object_version_details (Brtb_ver.pmod, Brtb_ver.obj-type, Brtb_ver.object, Brtb_ver.version, OUTPUT Mdescription, OUTPUT Mtextlines).

          DISPLAY STREAM Sout
            Brtb_ver.obj-type
            Brtb_ver.pmod   FORMAT "X(50)"
            Brtb_ver.object FORMAT "X(60)" 
            WITH FRAME versions-frame DOWN STREAM-IO WIDTH 120.

          IF PshowDetails THEN
            DO Mi = 1 TO 9:
              Mline = SUBSTRING(Mtextlines,(Mi - 1) * 76 + 1, 76).
              IF TRIM(Mline) <> "" THEN
                PUT STREAM Sout Mline FORMAT "x(120)" SKIP.
            END.

          /*
           Show version notes
          */
          IF PshowVerNotes THEN DO:
            PUT STREAM Sout "   ------------- Version Note -------------" SKIP.
            MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', Brtb_ver.upd-notes, 60).
            DO WHILE MlineOut <> ?:
              PUT STREAM Sout UNFORMATTED "   " MlineOut SKIP.
              MlineOut = DYNAMIC-FUNCTION('fnRtbBreakLines', ?, 60).
            END.
          END.

          IF PshowDetails OR PshowVerNotes THEN
            PUT STREAM Sout SKIP(1).

        END. 
        
        /*
         Show task events 
        */
        IF CAN-FIND(FIRST Brtb_hist OF Brtb_task) THEN DO:
          PUT STREAM Sout UNFORMATTED SKIP(1) "Task Events" SKIP.
          PUT STREAM Sout UNFORMATTED FILL("-", 11) SKIP.
        END.
        
        FOR EACH Brtb_hist NO-LOCK
          WHERE Brtb_hist.task-num = Brtb_task.task-num
          BY Brtb_hist.event-counter DESCENDING:
            
          DISPLAY STREAM Sout
            Brtb_hist.event-counter
            Brtb_hist.action
            Brtb_hist.obj-type
            Brtb_hist.pmod   FORMAT "X(40)"
            Brtb_hist.object FORMAT "X(50)"
            WITH FRAME hist-frame DOWN STREAM-IO WIDTH 120.
            
        END.
        
      END. /* pshowobjects */
      
    END.   /* for each brtb_task */

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  END. /* $RPT-BLOCK */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

